﻿Imports System.Security.Cryptography

Public Class frmRSA
    Private Sub Button1_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button1.Click

        ' Erstellt einen neuen zufälligen Schlüssel
        Dim oRsaProvider As New RSACryptoServiceProvider
        Dim btData() As Byte = System.Text.Encoding.UTF8.GetBytes(txtData.Text)

        Try
            If txtPrivateKey.Text = "" Then
                ' Generierten, zufälligen Schlüssel merken
                txtPrivateKey.Text = oRsaProvider.ToXmlString(True)
                txtPublicKey.Text = oRsaProvider.ToXmlString(False)
            Else
                ' Bereits generierten privaten Schlüssel importieren
                oRsaProvider.FromXmlString(txtPrivateKey.Text)
            End If

            Dim btSignature As Byte() = _
                oRsaProvider.SignData(btData, GetType(SHA1))

            txtSignature.Text = Convert.ToBase64String(btSignature)
            Catch
            ' Möglicherweise ist der private Schlüssel nicht valide?
            MessageBox.Show("Signatur konnte nicht erstellt werden!")
        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button2.Click

        Dim oRsaProvider As New RSACryptoServiceProvider
        Dim btData() As Byte = System.Text.Encoding.UTF8.GetBytes(txtData.Text)

        Try
            Dim btSignature() As Byte = _
                Convert.FromBase64String(txtSignature.Text)

            oRsaProvider.FromXmlString(txtPublicKey.Text)
            MessageBox.Show("Signatur gültig: " & _
                oRsaProvider.VerifyData(btData, GetType(SHA1), btSignature))
        Catch
            ' Möglicherweise ist der öffentliche Schlüssel nicht valide?
            MessageBox.Show("Signatur konnte nicht überprüft werden!")
        End Try
    End Sub
End Class